<?php 

	// no direct access
	defined('_JEXEC') or die('Restricted access');

	require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'route.php');
	require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'utilities.php');
	$jspath = JPATH_BASE.DS.'components'.DS.'com_community';
	include_once($jspath.DS.'libraries'.DS.'core.php');
	
	class JBSK2ContentHelper {
		
		private $plgParams;
		private $plgUserParams;
		private $jsActiveUser;
		private $loggedUser;
		
		private $cid;
		private $ordering;
		
		private $db;
		
		function __construct($plgParams) {
			jimport('joomla.filesystem.file');
			$this->plgParams = $plgParams; 
			$this->jsActiveUser = CFactory::getActiveProfile();
			$this->loggedUser = JFactory::getUser();
			$this->cid = $plgParams->get('category_id', NULL);
			$this->ordering = $plgParams->get('itemsOrdering');
			$this->db = &JFactory::getDBO();				
		}
		
		function getItems() {
			$query = $this->buildQuery();
			$this->db->setQuery($query, 0, $this->plgParams->get('items_limit', 5));
			
			$items = $this->db->loadObjectList();
			
			if (count($items)) {  
				foreach ($items as $item) {
					require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'models'.DS.'item.php');
					$model = new K2ModelItem;
					
					if ($this->plgParams->get('itemImage')) {
						$item = $this->getK2ItemImage($item);
					}       
        
					//Read more link
					$item->link = urldecode(JRoute::_(K2HelperRoute::getItemRoute($item->id.':'.urlencode($item->alias), $item->catid.':'.urlencode($item->categoryalias))));
       
					//Tags
					if ($this->plgParams->get('itemTags')) {
						$item = $this->getK2ItemTags($item, $model);
					}
        
					//Category link
					if ($this->plgParams->get('itemCategory'))
						$item->categoryLink = urldecode(JRoute::_(K2HelperRoute::getCategoryRoute($item->catid.':'.urlencode($item->categoryalias))));
          
					//Extra fields
					if ($this->plgParams->get('itemExtraFields')) {
						$item->extra_fields = $model->getItemExtraFields($item->extra_fields);
					}
        
					//Comments counter
					if ($this->plgParams->get('itemCommentsCounter'))
						$item->numOfComments = $model->countItemComments($item->id);
          
					//Attachments
					if ($this->plgParams->get('itemAttachments'))
						$item->attachments = $model->getItemAttachments($item->id);
          
					//Video
					if ($this->plgParams->get('itemVideo')) {
						$dispatcher = &JDispatcher::getInstance();
						JPluginHelper::importPlugin('content', 'jw_allvideos');
						$this->plgParams->set('vfolder', 'media/k2/videos');
						$item->text = $item->video;			
						$item->video = $item->text;
					}
        
					// Introtext
					$item->text = '';
					if ($this->plgParams->get('itemIntroText')) {
						// Word limit
						if ($this->plgParams->get('itemIntroTextWordLimit')) {
							$item->text .= K2HelperUtilities::wordLimit($item->introtext, $this->plgParams->get('itemIntroTextWordLimit'));
						} else {
							$item->text .= $item->introtext;
						}
					}
                        
					//Author
					if ($this->plgParams->get('itemAuthor')) {
						if (! empty($item->created_by_alias)) {
							$item->author = $item->created_by_alias;
							$item->authorGender = NULL;
							if ($this->plgParams->get('itemAuthorAvatar'))
								$item->authorAvatar = K2HelperUtilities::getAvatar('alias');
						} else {
							$author = &JFactory::getUser($item->created_by);
							$item->author = $author->name;
							$query = "SELECT `gender` FROM #__k2_users WHERE userID={$author->id}";
							$this->db->setQuery($query, 0, 1);
							$item->authorGender = $this->db->loadResult();
							if ($this->plgParams->get('itemAuthorAvatar')) {
								$componentParams = &JComponentHelper::getParams('com_k2');
								$item->authorAvatar = K2HelperUtilities::getAvatar($author->id, $author->email, $componentParams->get('userImageWidth'));
							}
							//Author Link
							$item->authorLink = JRoute::_(K2HelperRoute::getUserRoute($item->created_by));
						}
					}
					$rows[] = $item;
				}				
				return $rows;
			} 

			
		}
		private function buildQuery() {
			$aid = $this->loggedUser->get('aid');
					
			$jnow = &JFactory::getDate();
			$now = $jnow->toMySQL();
			$nullDate = $this->db->getNullDate();
			
			// Building query
			$query = "SELECT i.*, c.name AS categoryname,c.id AS categoryid, c.alias AS categoryalias, c.params AS categoryparams";
			if ($this->ordering == 'best') $query .= ", (r.rating_sum/r.rating_count) AS rating";      
			$query .= " FROM #__k2_items as i LEFT JOIN #__k2_categories c ON c.id = i.catid";    
			if ($this->ordering == 'best') $query .= " LEFT JOIN #__k2_rating r ON r.itemID = i.id";     
			$query .= " WHERE i.published = 1 AND i.access <= {$aid} AND i.trash = 0 AND c.published = 1 AND c.access <= {$aid} AND c.trash = 0";				
			$query .=  " AND i.created_by = " . (int)$this->jsActiveUser->id ;    
			$query .= " AND ( i.publish_up = ".$this->db->Quote($nullDate)." OR i.publish_up <= ".$this->db->Quote($now)." )";
			$query .= " AND ( i.publish_down = ".$this->db->Quote($nullDate)." OR i.publish_down >= ".$this->db->Quote($now)." )";
			$query .= $this->buildQueryCatFilter() . $this->buildExtraQueryCondition();
			$query .= " ORDER BY ".$this->buildQueryOrderBy();
			
			return $query;			
		}
		private function buildQueryCatFilter() {
			$query = '';
			if ($this->plgParams->get('catfilter')) {
				if (!is_null($this->cid)) {
					if (is_array($this->cid)) {
						if ($this->plgParams->get('getChildren')) {          
							require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'models'.DS.'itemlist.php');
							$allChildren = array();
							foreach ($this->cid as $id) {
								$categories = K2ModelItemlist::getCategoryChilds($id);
								$categories[] = $id;
								$categories = @array_unique($categories);
								$allChildren = @array_merge($allChildren, $categories);
							}            
							$allChildren = @array_unique($allChildren);
							$sql = @implode(',', $allChildren);
							$query .= " AND i.catid IN ({$sql})";            
						} else {
							$query .= " AND i.catid IN(".implode(',', $cid).")";
						}          
					} else {
						if ($this->plgParams->get('getChildren')) {
							require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'models'.DS.'itemlist.php');
							$categories = K2ModelItemlist::getCategoryChilds($cid);
							$categories[] = $cid;
							$categories = @array_unique($categories);
							$sql = @implode(',', $categories);
							$query .= " AND i.catid IN ({$sql})";
						} else {
							$query .= " AND i.catid={$cid}";
						}          
					}
				}
			}
			return $query;
		}
		
		private function buildExtraQueryCondition () {
			$query = '';
			if ($this->plgParams->get('FeaturedItems') == '0') $query .= " AND i.featured != 1";      
			if ($this->plgParams->get('FeaturedItems') == '2') $query .= " AND i.featured = 1";
			return $query;
		}
		
		private function buildQueryOrderBy () {
			$orderby = '';
			switch ($this->ordering) {    
				case 'date':
					$orderby = 'i.created ASC';
				break;        
				case 'rdate':
					$orderby = 'i.created DESC';
					break;        
				case 'alpha':
					$orderby = 'i.title';
					break;        
				case 'ralpha':
					$orderby = 'i.title DESC';
					break;        
				case 'order':
					if ($this->plgParams->get('FeaturedItems') == '2') $orderby = 'i.featured_ordering';
					else $orderby = 'i.ordering';
					break;        
				case 'hits':
					$orderby = 'i.hits DESC';
					break;        
				case 'rand':
					$orderby = 'RAND()';
					break;        
				case 'best':
					$orderby = 'rating DESC';
					break;        
				default:
					$orderby = 'i.id DESC';
				break;
			}	
			return $orderby;
		}
      
		private function getK2ItemImage ($item) {					       
			if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_XS.jpg'))
				$item->imageXSmall = JURI::root().'media/k2/items/cache/'.md5("Image".$item->id).'_XS.jpg';            
			if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_S.jpg'))
				$item->imageSmall = JURI::root().'media/k2/items/cache/'.md5("Image".$item->id).'_S.jpg';            
			if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_M.jpg'))
				$item->imageMedium = JURI::root().'media/k2/items/cache/'.md5("Image".$item->id).'_M.jpg';            
			if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_L.jpg'))
				$item->imageLarge = JURI::root().'media/k2/items/cache/'.md5("Image".$item->id).'_L.jpg';            
			if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_XL.jpg'))
				$item->imageXLarge = JURI::root().'media/k2/items/cache/'.md5("Image".$item->id).'_XL.jpg';            
			if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_Generic.jpg'))
				$item->imageGeneric = JURI::root().'media/k2/items/cache/'.md5("Image".$item->id).'_Generic.jpg';            
			$image = 'image'.$this->plgParams->get('itemImgSize');
			if (isset($item->$image)) $item->image = $item->$image;
			return $item;
        }
		
		private function getK2ItemTags ($item, $model) {
			$tags = $model->getItemTags($item->id);
			for ($i = 0; $i < sizeof($tags); $i++) {
				$tags[$i]->link = JRoute::_(K2HelperRoute::getTagRoute($tags[$i]->name));
			}
			$item->tags = $tags;
			return $item;
		}    
	}
?>